"""

Tools to generate a chunk.
Still has no functionality to generate transitions between different lods.

"""

from panda3d.core import GeomNode, GeomTriangles, GeomVertexData
from panda3d.core import GeomVertexFormat, GeomVertexWriter, Geom, NodePath


def generateChunk(mesh_subdivisions=4, mesh_scale=1.0):

    subdivisions = mesh_subdivisions + 1
    offset = -(float(subdivisions - 1) / 2.0)

    GeomVData = GeomVertexData(
        'geomdata', GeomVertexFormat.getV3(), Geom.UHStatic)
    MainGeom = Geom(GeomVData)
    triangles = GeomTriangles(Geom.UHStatic)
    v_writer = GeomVertexWriter(GeomVData, 'vertex')

    # create vertices
    for x in xrange(subdivisions):
        for y in xrange(subdivisions):
            v_writer.addData3f((float(x) + offset) * mesh_scale,
                               (float(y) + offset) * mesh_scale, 0.0)

    # create tris
    for y in xrange(subdivisions - 1):
        for x in xrange(subdivisions - 1):
            offset = y * subdivisions + x
            triangles.addVertices(offset + subdivisions, offset + 1, offset)
            triangles.addVertices(
                offset + subdivisions, offset + subdivisions + 1, offset + 1)

    # finalize
    triangles.closePrimitive()
    triangles = triangles.decompose()
    MainGeom.addPrimitive(triangles)
    node = GeomNode('chunk')
    node.addGeom(MainGeom)
    main_node = NodePath(node)
    main_node.flattenStrong()
    return main_node
