#version 400


in vec4 p3d_Vertex;
uniform mat4 p3d_ViewProjectionMatrix;
uniform mat4 trans_model_to_world;

uniform sampler2D heightfield;

out vec2 texcoord;

void main() {

    vec4 worldPos = trans_model_to_world *  p3d_Vertex;

    texcoord = (worldPos.xy / 512.0) + 0.5;

    worldPos.z += texture(heightfield, texcoord).x * 250.0;


    gl_Position = p3d_ViewProjectionMatrix * worldPos;
}

